/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.xtext.example.methodname.methodName.Declaration;
import org.xtext.example.methodname.methodName.Kind;
import org.xtext.example.methodname.methodName.MethodNamePackage;
import org.xtext.example.methodname.methodName.Rule;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.RuleImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.RuleImpl#getKind <em>Kind</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.RuleImpl#getDecls <em>Decls</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.RuleImpl#getCompOp <em>Comp Op</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.RuleImpl#getCompValue <em>Comp Value</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RuleImpl extends MinimalEObjectImpl.Container implements Rule
{
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getKind() <em>Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKind()
   * @generated
   * @ordered
   */
  protected static final Kind KIND_EDEFAULT = Kind.KIND_INTERFACE;

  /**
   * The cached value of the '{@link #getKind() <em>Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKind()
   * @generated
   * @ordered
   */
  protected Kind kind = KIND_EDEFAULT;

  /**
   * The cached value of the '{@link #getDecls() <em>Decls</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDecls()
   * @generated
   * @ordered
   */
  protected EList<Declaration> decls;

  /**
   * The default value of the '{@link #getCompOp() <em>Comp Op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompOp()
   * @generated
   * @ordered
   */
  protected static final String COMP_OP_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getCompOp() <em>Comp Op</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompOp()
   * @generated
   * @ordered
   */
  protected String compOp = COMP_OP_EDEFAULT;

  /**
   * The default value of the '{@link #getCompValue() <em>Comp Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompValue()
   * @generated
   * @ordered
   */
  protected static final int COMP_VALUE_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getCompValue() <em>Comp Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCompValue()
   * @generated
   * @ordered
   */
  protected int compValue = COMP_VALUE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RuleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MethodNamePackage.Literals.RULE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.RULE__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Kind getKind()
  {
    return kind;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setKind(Kind newKind)
  {
    Kind oldKind = kind;
    kind = newKind == null ? KIND_EDEFAULT : newKind;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.RULE__KIND, oldKind, kind));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<Declaration> getDecls()
  {
    if (decls == null)
    {
      decls = new EObjectResolvingEList<Declaration>(Declaration.class, this, MethodNamePackage.RULE__DECLS);
    }
    return decls;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getCompOp()
  {
    return compOp;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setCompOp(String newCompOp)
  {
    String oldCompOp = compOp;
    compOp = newCompOp;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.RULE__COMP_OP, oldCompOp, compOp));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getCompValue()
  {
    return compValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setCompValue(int newCompValue)
  {
    int oldCompValue = compValue;
    compValue = newCompValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.RULE__COMP_VALUE, oldCompValue, compValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MethodNamePackage.RULE__NAME:
        return getName();
      case MethodNamePackage.RULE__KIND:
        return getKind();
      case MethodNamePackage.RULE__DECLS:
        return getDecls();
      case MethodNamePackage.RULE__COMP_OP:
        return getCompOp();
      case MethodNamePackage.RULE__COMP_VALUE:
        return getCompValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MethodNamePackage.RULE__NAME:
        setName((String)newValue);
        return;
      case MethodNamePackage.RULE__KIND:
        setKind((Kind)newValue);
        return;
      case MethodNamePackage.RULE__DECLS:
        getDecls().clear();
        getDecls().addAll((Collection<? extends Declaration>)newValue);
        return;
      case MethodNamePackage.RULE__COMP_OP:
        setCompOp((String)newValue);
        return;
      case MethodNamePackage.RULE__COMP_VALUE:
        setCompValue((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.RULE__NAME:
        setName(NAME_EDEFAULT);
        return;
      case MethodNamePackage.RULE__KIND:
        setKind(KIND_EDEFAULT);
        return;
      case MethodNamePackage.RULE__DECLS:
        getDecls().clear();
        return;
      case MethodNamePackage.RULE__COMP_OP:
        setCompOp(COMP_OP_EDEFAULT);
        return;
      case MethodNamePackage.RULE__COMP_VALUE:
        setCompValue(COMP_VALUE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.RULE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case MethodNamePackage.RULE__KIND:
        return kind != KIND_EDEFAULT;
      case MethodNamePackage.RULE__DECLS:
        return decls != null && !decls.isEmpty();
      case MethodNamePackage.RULE__COMP_OP:
        return COMP_OP_EDEFAULT == null ? compOp != null : !COMP_OP_EDEFAULT.equals(compOp);
      case MethodNamePackage.RULE__COMP_VALUE:
        return compValue != COMP_VALUE_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", kind: ");
    result.append(kind);
    result.append(", compOp: ");
    result.append(compOp);
    result.append(", compValue: ");
    result.append(compValue);
    result.append(')');
    return result.toString();
  }

} //RuleImpl
